Botan 2.19.5 Crypto and TLS for C&

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
Botan::McEliece_PublicKey Class Reference

`#include <mceliece.h>`

Inheritance diagram for Botan::McEliece_PublicKey:

## Public Member Functions
std::string | algo_name () const override
AlgorithmIdentifier | algorithm_identifier () const override
bool | check_key (RandomNumberGenerator &, bool) const override
virtual std::unique_ptr< PK_Ops::Encryption > | create_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const
std::unique_ptr< PK_Ops::KEM_Encryption > | create_kem_encryption_op (RandomNumberGenerator &rng, const std::string &params, const std::string &provider) const override
virtual std::unique_ptr< PK_Ops::Verification > | create_verification_op (const std::string &params, const std::string &provider) const
virtual Signature_Format | default_x509_signature_format () const
size_t | estimated_strength () const override
std::string | fingerprint_public (const std::string &alg="SHA-256") const
size_t | get_code_length () const
size_t | get_message_word_bit_length () const
virtual OID | get_oid () const
const std::vector< uint8_t > & | get_public_matrix () const
size_t | get_t () const
size_t | key_length () const override
| McEliece_PublicKey (const McEliece_PublicKey &other)=default
| McEliece_PublicKey (const std::vector< uint8_t > &key_bits)
| McEliece_PublicKey (const std::vector< uint8_t > &pub_matrix, size_t t, size_t the_code_length)
virtual size_t | message_part_size () const
virtual size_t | message_parts () const
bool | operator!= (const McEliece_PublicKey &other) const
McEliece_PublicKey & | operator= (const McEliece_PublicKey &other)=default
bool | operator== (const McEliece_PublicKey &other) const
std::vector< uint8_t > | public_key_bits () const override
secure_vector< uint8_t > | random_plaintext_element (RandomNumberGenerator &rng) const
std::vector< uint8_t > | subject_public_key () const
virtual | ~McEliece_PublicKey ()=default

## Protected Member Functions
| McEliece_PublicKey ()

## Protected Attributes
size_t | m_code_length
std::vector< uint8_t > | m_public_matrix
size_t | m_t

## Detailed Description

Definition at line 24 of file mceliece.h.

## Constructor & Destructor Documentation

## ◆ McEliece_PublicKey() [1/4]

Botan::McEliece_PublicKey::McEliece_PublicKey | ( | const std::vector< uint8_t > & | key_bits | ) |
| explicit

Definition at line 106 of file mceliece_key.cpp.

107 {
108 BER_Decoder dec(key_bits);
109 size_t n;
110 size_t t;
111 dec.start_cons(SEQUENCE)
112 .start_cons(SEQUENCE)
113 .decode(n)
114 .decode(t)
115 .end_cons()
116 .decode(m_public_matrix, OCTET_STRING)
117 .end_cons();
118 m_t = t;
119 m_code_length = n;
120 }
Botan::McEliece_PublicKey::m_t
size_t m_t
Definition: mceliece.h:69
Botan::McEliece_PublicKey::m_public_matrix
std::vector< uint8_t > m_public_matrix
Definition: mceliece.h:68
Botan::McEliece_PublicKey::m_code_length
size_t m_code_length
Definition: mceliece.h:70
Botan::SEQUENCE
@ SEQUENCE
Definition: asn1_obj.h:42
Botan::OCTET_STRING
@ OCTET_STRING
Definition: asn1_obj.h:38

References Botan::BER_Decoder::decode(), Botan::BER_Decoder::end_cons(), m_code_length, m_public_matrix, m_t, Botan::OCTET_STRING, Botan::SEQUENCE, and Botan::BER_Decoder::start_cons().

## ◆ McEliece_PublicKey() [2/4]

Botan::McEliece_PublicKey::McEliece_PublicKey | ( | const std::vector< uint8_t > & | pub_matrix,
|  | size_t | t,
|  | size_t | the_code_length
| ) |  |
| inline

Definition at line 29 of file mceliece.h.

29 :
30 m_public_matrix(pub_matrix),
31 m_t(t),
32 m_code_length(the_code_length){}

## ◆ McEliece_PublicKey() [3/4]

Botan::McEliece_PublicKey::McEliece_PublicKey | ( | const McEliece_PublicKey & | other | ) |
| default

## ◆ ~McEliece_PublicKey()

virtual Botan::McEliece_PublicKey::~McEliece_PublicKey | ( |  | ) |
| virtual default

## ◆ McEliece_PublicKey() [4/4]

Botan::McEliece_PublicKey::McEliece_PublicKey | ( |  | ) |
| inline protected

Definition at line 66 of file mceliece.h.

66: m_t(0), m_code_length(0) {}

## Member Function Documentation

## ◆ algo_name()

std::string Botan::McEliece_PublicKey::algo_name | ( |  | ) | const
| inline override virtual

Get the name of the underlying public key scheme.

Returns
  name of the public key scheme

Implements Botan::Public_Key.

Definition at line 40 of file mceliece.h.

40{ return "McEliece"; }

Referenced by Botan::McEliece_PrivateKey::create_kem_decryption_op(), and create_kem_encryption_op().

## ◆ algorithm_identifier()

AlgorithmIdentifier Botan::McEliece_PublicKey::algorithm_identifier | ( |  | ) | const
| override virtual

Returns
  X.509 AlgorithmIdentifier for this key

Implements Botan::Public_Key.

Definition at line 77 of file mceliece_key.cpp.

78 {
79 return AlgorithmIdentifier(get_oid(), AlgorithmIdentifier::USE_EMPTY_PARAM);
80 }
Botan::AlgorithmIdentifier::USE_EMPTY_PARAM
@ USE_EMPTY_PARAM
Definition: asn1_obj.h:432
Botan::Public_Key::get_oid
virtual OID get_oid() const
Definition: pk_keys.cpp:53

References Botan::Public_Key::get_oid(), and Botan::AlgorithmIdentifier::USE_EMPTY_PARAM.

## ◆ check_key()

bool Botan::McEliece_PublicKey::check_key | ( | RandomNumberGenerator & | rng,
|  | bool | strong
| ) |  | const
| inline override virtual

Test the key values for consistency.

Parameters

  rng | rng to use
  strong | whether to perform strong and lengthy version of the test

Returns
  true if the test is passed

Implements Botan::Public_Key.

Reimplemented in Botan::McEliece_PrivateKey.

Definition at line 49 of file mceliece.h.

50 { return true; }

## ◆ create_encryption_op()

std::unique_ptr< PK_Ops::Encryption > Botan::Public_Key::create_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return an encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::ElGamal_PublicKey, Botan::RSA_PublicKey, and Botan::SM2_PublicKey.

Definition at line 91 of file pk_keys.cpp.

94 {
95 throw Lookup_Error(algo_name() + " does not support encryption");
96 }
Botan::Public_Key::algo_name
virtual std::string algo_name() const =0

References Botan::Public_Key::algo_name().

Referenced by Botan::PK_Encryptor_EME::PK_Encryptor_EME().

## ◆ create_kem_encryption_op()

std::unique_ptr< PK_Ops::KEM_Encryption > Botan::McEliece_PublicKey::create_kem_encryption_op | ( | RandomNumberGenerator & | rng,
|  | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| override virtual

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a KEM encryption operation for this key/params or throw

Parameters

  rng | a random number generator. The PK_Op may maintain a reference to the RNG and use it many times. The rng must outlive any operations which reference it.
  params | additional parameters
  provider | the provider to use

Reimplemented from Botan::Public_Key.

Definition at line 365 of file mceliece_key.cpp.

368 {
369 if(provider == "base" || provider.empty())
370 return std::unique_ptr<PK_Ops::KEM_Encryption>(new MCE_KEM_Encryptor(*this, params));
371 throw Provider_Not_Found(algo_name(), provider);
372 }
Botan::McEliece_PublicKey::algo_name
std::string algo_name() const override
Definition: mceliece.h:40

References algo_name().

## ◆ create_verification_op()

std::unique_ptr< PK_Ops::Verification > Botan::Public_Key::create_verification_op | ( | const std::string & | params,
|  | const std::string & | provider
| ) |  | const
| virtual inherited

This is an internal library function exposed on key types. In almost all cases applications should use wrappers in pubkey.h

Return a verification operation for this key/params or throw

Parameters

  params | additional parameters
  provider | the provider to use

Reimplemented in Botan::XMSS_PublicKey, Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::Ed25519_PublicKey, Botan::GOST_3410_PublicKey, Botan::RSA_PublicKey, Botan::SM2_PublicKey, and Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 107 of file pk_keys.cpp.

109 {
110 throw Lookup_Error(algo_name() + " does not support verification");
111 }

References Botan::Public_Key::algo_name().

Referenced by Botan::XMSS_WOTS_Addressed_PublicKey::create_verification_op(), and Botan::PK_Verifier::PK_Verifier().

## ◆ default_x509_signature_format()

virtual Signature_Format Botan::Public_Key::default_x509_signature_format | ( |  | ) | const
| inline virtual inherited

Reimplemented in Botan::GOST_3410_PublicKey.

Definition at line 125 of file pk_keys.h.

126 {
127 return (this->message_parts() >= 2) ? DER_SEQUENCE : IEEE_1363;
128 }
Botan::Public_Key::message_parts
virtual size_t message_parts() const
Definition: pk_keys.h:112
Botan::DER_SEQUENCE
@ DER_SEQUENCE
Definition: pk_keys.h:23
Botan::IEEE_1363
@ IEEE_1363
Definition: pk_keys.h:23

References Botan::DER_SEQUENCE, and Botan::IEEE_1363.

Referenced by Botan::X509_Object::choose_sig_format(), and Botan::X509_Object::verify_signature().

## ◆ estimated_strength()

size_t Botan::McEliece_PublicKey::estimated_strength | ( |  | ) | const
| override virtual

Return the estimated strength of the underlying key against the best currently known attack. Note that this ignores anything but pure attacks against the key itself and do not take into account padding schemes, usage mistakes, etc which might reduce the strength. However it does suffice to provide an upper bound.

Returns
  estimated strength in bits

Implements Botan::Public_Key.

Definition at line 101 of file mceliece_key.cpp.

102 {
103 return mceliece_work_factor(m_code_length, m_t);
104 }
Botan::mceliece_work_factor
size_t mceliece_work_factor(size_t n, size_t t)
Definition: mce_workfactor.cpp:95

References m_code_length, m_t, and Botan::mceliece_work_factor().

## ◆ fingerprint_public()

std::string Botan::Public_Key::fingerprint_public | ( | const std::string & | alg = `"SHA-256"` | ) | const
| inherited

Returns
  Hash of the subject public key

Definition at line 77 of file pk_keys.cpp.

78 {
79 return create_hex_fingerprint(subject_public_key(), hash_algo);
80 }
Botan::Public_Key::subject_public_key
std::vector< uint8_t > subject_public_key() const
Definition: pk_keys.cpp:38
Botan::create_hex_fingerprint
std::string create_hex_fingerprint(const uint8_t bits[], size_t bits_len, const std::string &hash_name)
Definition: pk_keys.cpp:17
hash_algo
AlgorithmIdentifier hash_algo
Definition: x509_obj.cpp:22

References Botan::create_hex_fingerprint(), hash_algo, and Botan::Public_Key::subject_public_key().

## ◆ get_code_length()

size_t Botan::McEliece_PublicKey::get_code_length | ( |  | ) | const
| inline

Definition at line 53 of file mceliece.h.

53{ return m_code_length; }

Referenced by Botan::mceies_decrypt(), Botan::mceies_encrypt(), Botan::mceliece_decrypt(), Botan::mceliece_encrypt(), Botan::McEliece_PrivateKey::private_key_bits(), and public_key_bits().

## ◆ get_message_word_bit_length()

size_t Botan::McEliece_PublicKey::get_message_word_bit_length | ( |  | ) | const

Definition at line 54 of file mceliece_key.cpp.

55 {
56 size_t codimension = ceil_log2(m_code_length) * m_t;
57 return m_code_length - codimension;
58 }
Botan::ceil_log2
uint8_t ceil_log2(T x)
Definition: bit_ops.h:119

References Botan::ceil_log2(), m_code_length, and m_t.

Referenced by Botan::mceliece_decrypt(), and random_plaintext_element().

## ◆ get_oid()

OID Botan::Public_Key::get_oid | ( |  | ) | const
| virtual inherited

Get the OID of the underlying public key scheme.

Returns
  OID of the public key scheme

Reimplemented in Botan::XMSS_WOTS_Addressed_PublicKey.

Definition at line 53 of file pk_keys.cpp.

54 {
55 const OID o = OIDS::str2oid_or_empty(algo_name());
56 if(o.empty())
57 throw Lookup_Error("PK algo " + algo_name() + " has no defined OIDs");
58 return o;
59 }
Botan::OIDS::str2oid_or_empty
BOTAN_UNSTABLE_API OID str2oid_or_empty(const std::string &name)
Definition: oids.cpp:116

References Botan::Public_Key::algo_name(), Botan::OID::empty(), and Botan::OIDS::str2oid_or_empty().

Referenced by Botan::TPM_PrivateKey::algorithm_identifier(), Botan::Curve25519_PublicKey::algorithm_identifier(), Botan::DL_Scheme_PublicKey::algorithm_identifier(), Botan::EC_PublicKey::algorithm_identifier(), Botan::Ed25519_PublicKey::algorithm_identifier(), Botan::GOST_3410_PublicKey::algorithm_identifier(), algorithm_identifier(), Botan::RSA_PublicKey::algorithm_identifier(), and Botan::XMSS_WOTS_Addressed_PublicKey::get_oid().

## ◆ get_public_matrix()

const std::vector< uint8_t > & Botan::McEliece_PublicKey::get_public_matrix | ( |  | ) | const
| inline

Definition at line 55 of file mceliece.h.

55{ return m_public_matrix; }

Referenced by Botan::mceliece_encrypt().

## ◆ get_t()

size_t Botan::McEliece_PublicKey::get_t | ( |  | ) | const
| inline

Definition at line 52 of file mceliece.h.

52{ return m_t; }

Referenced by Botan::mceliece_encrypt(), Botan::McEliece_PrivateKey::private_key_bits(), and public_key_bits().

## ◆ key_length()

size_t Botan::McEliece_PublicKey::key_length | ( |  | ) | const
| override virtual

Return an integer value best approximating the length of the primary security parameter. For example for RSA this will be the size of the modulus, for ECDSA the size of the ECC group, and for McEliece the size of the code will be returned.

Implements Botan::Public_Key.

Definition at line 96 of file mceliece_key.cpp.

97 {
98 return m_code_length;
99 }

References m_code_length.

## ◆ message_part_size()

virtual size_t Botan::Public_Key::message_part_size | ( |  | ) | const
| inline virtual inherited

Returns how large each of the message parts refered to by message_parts() is

This function is public but applications should have few reasons to ever call this.

Returns
  size of the message parts in bits

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 123 of file pk_keys.h.

123{ return 0; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ message_parts()

virtual size_t Botan::Public_Key::message_parts | ( |  | ) | const
| inline virtual inherited

Returns more than 1 if the output of this algorithm (ciphertext, signature) should be treated as more than one value. This is used for algorithms like DSA and ECDSA, where the (r,s) output pair can be encoded as either a plain binary list or a TLV tagged DER encoding depending on the protocol.

This function is public but applications should have few reasons to ever call this.

Returns
  number of message parts

Reimplemented in Botan::DSA_PublicKey, Botan::ECDSA_PublicKey, Botan::ECGDSA_PublicKey, Botan::ECKCDSA_PublicKey, Botan::GOST_3410_PublicKey, and Botan::SM2_PublicKey.

Definition at line 112 of file pk_keys.h.

112{ return 1; }

Referenced by Botan::PK_Signer::PK_Signer(), and Botan::PK_Verifier::PK_Verifier().

## ◆ operator!=()

bool Botan::McEliece_PublicKey::operator!= | ( | const McEliece_PublicKey & | other | ) | const
| inline

Definition at line 58 of file mceliece.h.

58{ return !(*this == other); }

## ◆ operator=()

McEliece_PublicKey & Botan::McEliece_PublicKey::operator= | ( | const McEliece_PublicKey & | other | ) |
| default

## ◆ operator==()

bool Botan::McEliece_PublicKey::operator== | ( | const McEliece_PublicKey & | other | ) | const

Definition at line 290 of file mceliece_key.cpp.

291 {
292 if(m_public_matrix != other.m_public_matrix)
293 {
294 return false;
295 }
296 if(m_t != other.m_t)
297 {
298 return false;
299 }
300 if( m_code_length != other.m_code_length)
301 {
302 return false;
303 }
304 return true;
305 }

References m_code_length, m_public_matrix, and m_t.

## ◆ public_key_bits()

std::vector< uint8_t > Botan::McEliece_PublicKey::public_key_bits | ( |  | ) | const
| override virtual

Returns
  BER encoded public key bits

Implements Botan::Public_Key.

Definition at line 82 of file mceliece_key.cpp.

83 {
84 std::vector<uint8_t> output;
85 DER_Encoder(output)
86 .start_cons(SEQUENCE)
87 .start_cons(SEQUENCE)
88 .encode(static_cast<size_t>(get_code_length()))
89 .encode(static_cast<size_t>(get_t()))
90 .end_cons()
91 .encode(m_public_matrix, OCTET_STRING)
92 .end_cons();
93 return output;
94 }
Botan::McEliece_PublicKey::get_t
size_t get_t() const
Definition: mceliece.h:52
Botan::McEliece_PublicKey::get_code_length
size_t get_code_length() const
Definition: mceliece.h:53

References Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), get_code_length(), get_t(), m_public_matrix, Botan::OCTET_STRING, Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

## ◆ random_plaintext_element()

secure_vector< uint8_t > Botan::McEliece_PublicKey::random_plaintext_element | ( | RandomNumberGenerator & | rng | ) | const

Definition at line 60 of file mceliece_key.cpp.

61 {
62 const size_t bits = get_message_word_bit_length();
63
64 secure_vector<uint8_t> plaintext((bits+7)/8);
65 rng.randomize(plaintext.data(), plaintext.size());
66
67 // unset unused bits in the last plaintext byte
68 if(uint32_t used = bits % 8)
69 {
70 const uint8_t mask = (1 << used) - 1;
71 plaintext[plaintext.size() - 1] &= mask;
72 }
73
74 return plaintext;
75 }
Botan::McEliece_PublicKey::get_message_word_bit_length
size_t get_message_word_bit_length() const
Definition: mceliece_key.cpp:54

References get_message_word_bit_length(), and Botan::RandomNumberGenerator::randomize().

Referenced by Botan::McEliece_PrivateKey::check_key().

## ◆ subject_public_key()

std::vector< uint8_t > Botan::Public_Key::subject_public_key | ( |  | ) | const
| inherited

Returns
  X.509 subject key encoding for this key object

Definition at line 38 of file pk_keys.cpp.

39 {
40 std::vector<uint8_t> output;
41
42 DER_Encoder(output).start_cons(SEQUENCE)
43 .encode(algorithm_identifier())
44 .encode(public_key_bits(), BIT_STRING)
45 .end_cons();
46
47 return output;
48 }
Botan::Public_Key::algorithm_identifier
virtual AlgorithmIdentifier algorithm_identifier() const =0
Botan::Public_Key::public_key_bits
virtual std::vector< uint8_t > public_key_bits() const =0
Botan::BIT_STRING
@ BIT_STRING
Definition: asn1_obj.h:37

References Botan::Public_Key::algorithm_identifier(), Botan::BIT_STRING, Botan::DER_Encoder::encode(), Botan::DER_Encoder::end_cons(), Botan::Public_Key::public_key_bits(), Botan::SEQUENCE, and Botan::DER_Encoder::start_cons().

Referenced by Botan::X509::BER_encode(), Botan::PKCS10_Request::create(), Botan::Public_Key::fingerprint_public(), and Botan::X509::PEM_encode().

## Member Data Documentation

## ◆ m_code_length

size_t Botan::McEliece_PublicKey::m_code_length
| protected

Definition at line 70 of file mceliece.h.

Referenced by estimated_strength(), get_message_word_bit_length(), key_length(), Botan::McEliece_PrivateKey::McEliece_PrivateKey(), McEliece_PublicKey(), and operator==().

## ◆ m_public_matrix

std::vector<uint8_t> Botan::McEliece_PublicKey::m_public_matrix
| protected

Definition at line 68 of file mceliece.h.

Referenced by Botan::McEliece_PrivateKey::McEliece_PrivateKey(), McEliece_PublicKey(), operator==(), Botan::McEliece_PrivateKey::private_key_bits(), and public_key_bits().

## ◆ m_t

size_t Botan::McEliece_PublicKey::m_t
| protected

Definition at line 69 of file mceliece.h.

Referenced by estimated_strength(), get_message_word_bit_length(), Botan::McEliece_PrivateKey::McEliece_PrivateKey(), McEliece_PublicKey(), and operator==().

The documentation for this class was generated from the following files:

- src/lib/pubkey/mce/mceliece.h
- src/lib/pubkey/mce/mceliece_key.cpp